Public Vulnerability Reports

Oracle Database Server dbms_system.ksdwrt Buffer Overflow Vulnerability

09.02.04

BACKGROUND

Oracle Database Server is a family of database products that range from
personal databases to enterprise solutions. Further information is
available at:

http://www.oracle.com/database/index.html

DESCRIPTION

Remote exploitation of a buffer overflow vulnerability in Oracle Corp.'s
Oracle Database Server could allow attackers to crash the server and
potentially execute arbitrary code.

The problem specifically exists within dbms_system.ksdwrt(), a function
that allows writing messages to alert.log. If a long string is passed as
the second argument to this function, a buffer overflow occurs.

ANALYSIS

Successful exploitation allows authorized remote users to cause the
Oracle server process to crash and potentially execute arbitrary code.
Authorized users include any users who are members of the SYS or SYSTEM
roles, as well as users who are granted execute permissions on the
dbms_system package.

Successful exploitation of this vulnerability on Microsoft Corp.'s
Windows platforms can lead to a full system compromise, as most systems
are configured to run the Oracle service under Local System. Successful
exploitation of this vulnerability on Linux/Unix platforms usually
compromises only the database because the Oracle service runs under a
non-privileged account.

In cases where Oracle Internet Directory has been installed, an added
exploitation vector exists. This is because Oracle Internet Directory
creates a database user called ODSCOMMON that has a default password of
ODSCOMMON which cannot be changed, thereby allowing any attacker to
connect to the database server and exploit this vulnerability.

DETECTION

The following versions of Oracle Database Server are affected:

    Oracle 9i Database Server Release 2, versions 9.2.0.3 and 9.2.0.4
    Oracle 9i Database Server Release 1, versions 9.0.1.4 and 9.0.1.5
    Oracle 8i Database Server Release 1, version 8.1.7.4

Oracle 10g Database Server is not affected.

WORKAROUND

iDEFENSE is currently unaware of any workarounds that fully address this
issue.

VENDOR RESPONSE

"[This] issue [has] been addressed in Alert 68."

http://www.oracle.com/technology/deploy/security/pdf/2004alert68.pdf

CVE INFORMATION

The Common Vulnerabilities and Exposures (CVE) project has assigned the
name CAN-2004-0638 to this issue. This is a candidate for inclusion in
the CVE list (http://cve.mitre.org), which standardizes names for
security problems.

DISCLOSURE TIMELINE

05/06/2004    Initial vendor notification
05/06/2004    iDEFENSE clients notified
05/06/2004    Initial vendor response
09/02/2004    Public disclosure

CREDIT

Alexander Kornbrust (www.red-database-security.com) is credited with
this discovery.

Get paid for vulnerability research
http://www.idefense.com/poi/teams/vcp.jsp

LEGAL NOTICES

Copyright © 2004 Verisign, Inc.

Permission is granted for the redistribution of this alert
electronically. It may not be edited in any way without the express
written consent of iDEFENSE. If you wish to reprint the whole or any
part of this alert in any other medium other than electronically, please
email customerservice@idefense.com for permission.

Disclaimer: The information in the advisory is believed to be accurate
at the time of publishing based on currently available information. Use
of the information constitutes acceptance for use in an AS IS condition.
There are no warranties with regard to this information. Neither the
author nor the publisher accepts any liability for any direct, indirect,
or consequential loss or damage arising from use of, or reliance on,
this information.